stages:
    - build
    - test
    - deploy

workflow:
    rules:
        - if: $CI_MERGE_REQUEST_ID
          when: never
        - when: always

.rules-review: &rules-review
    rules:
        - if: '$CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH'
          when: never
        - if: $CI_COMMIT_TAG != null
          when: never
        - when: on_success

.rules-staging: &rules-staging
    rules:
        - if: '$CI_COMMIT_BRANCH == "/^release\/.+/"'
          when: on_success
        - when: never

.rules-production: &rules-production
    rules:
        - if: '$CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH'
          when: on_success
        - when: never

.build: &build
    stage: build
    image:
        name: squidfunk/mkdocs-material:8.3.7
        entrypoint:
            - ""
    script:
        - mkdocs build
    artifacts:
        paths:
            - site

build:review:
    <<: *build
    <<: *rules-review

build:staging:
    <<: *build
    <<: *rules-staging

build:production:
    <<: *build
    <<: *rules-production

.test: &test
    stage: test

test:markdownlint:
    <<: *test
    image: ruby:latest
    before_script:
        - gem install mdl
    script:
        - git ls-files -z '*.md' | xargs -0 mdl --style .mdl.rb

test:linkchecker:
    <<: *test
    image:
        name: ghcr.io/linkchecker/linkchecker:latest
        entrypoint:
            - ""
    script:
        - linkchecker site/index.html

.deploy: &deploy
    stage: deploy
    image:
        name: squidfunk/mkdocs-material
        entrypoint:
            - ""
    script:
        - mkdocs build -d public
    artifacts:
        paths:
            - public

deploy:review:
    <<: *deploy
    <<: *rules-review
    environment:
        name: review/$CI_COMMIT_REF_NAME
        url: "https://beautifulcanoe.gitlab.io/-/identity/$CI_PROJECT_NAME/-/jobs/$CI_JOB_ID/artifacts/public/index.html"
        auto_stop_in: 2 weeks

deploy:staging:
    <<: *deploy
    <<: *rules-staging
    environment:
        name: staging/$CI_COMMIT_REF_NAME
        url: "https://beautifulcanoe.gitlab.io/-/identity/$CI_PROJECT_NAME/-/jobs/$CI_JOB_ID/artifacts/public/index.html"
        auto_stop_in: 2 week

pages:
    <<: *deploy
    <<: *rules-production
    after_script:
        - find public -type f -regex '.*\.\(htm\|html\|txt\|text\|js\|css\)$' -exec gzip -f -k {} \;
    environment:
        name: production
        url: https://brand.beautifulcanoe.com/
